<template>
  <Modal v-model="showModalFunctionInit" :mask-closable="false" :closable="false" :title="modalTitle" :value="value"
         width="820" v-draggable="options">

    <i-form label-position="right" :label-width="100" ref="functionInitForm" :model="bean" :rules="rules" inline>
      <Row>
        <i-col :span="12">
          <Form-item label="功能编码" prop="code" class="ivu-form-item-search">
            <Input v-model="bean.code" style="width: 243px" :disabled="disabled"></Input>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="类型" prop="type" class="ivu-form-item-search">
            <Select v-model="bean.type" style="width: 243px" :disabled="disabled">
              <Option :value="1" :key="1">按钮</Option>
              <Option :value="2" :key="2">其他</Option>
            </Select>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="功能名称" prop="name" class="ivu-form-item-search">
            <Input v-model="bean.name" style="width: 243px" :disabled="disabled"></Input>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="是否默认授权" prop="isDefault" class="ivu-form-item-search">
            <Select v-model="bean.isDefault" style="width: 243px" :disabled="disabled">
              <Option :value="1" :key="1">是</Option>
              <Option :value="0" :key="0">否</Option>
            </Select>
          </Form-item>
        </i-col>
        <!--<i-col :span="12">
          <Form-item label="状态" prop="state" class="ivu-form-item-search">
            <Select v-model="bean.state" style="width: 243px" :disabled="disabled">
              <Option :value="1" :key="1">正常</Option>
              <Option :value="0" :key="0">禁用</Option>
            </Select>
          </Form-item>
        </i-col>-->
        <i-col :span="12">
          <Form-item label="备注" class="ivu-form-item-search">
            <Input v-model="bean.remark" style="width: 243px" :disabled="disabled"></Input>
          </Form-item>
        </i-col>
      </Row>
    </i-form>
    <template #footer>
    <div >
      <Button @click="cancel">关闭</Button>
      <Button type="primary" :loading="saveLoading" @click="ok('functionInitForm')" v-if="showSaveBtn">保存</Button>
    </div>
    </template>
  </Modal>
</template>

<script>
  import { addFunctionInit, editFunctionInit } from '../../../../api/rbac/functionInit-api'

  let $this
  export default {
    name: 'functionInitModal',
    components: {},
    props: {
      show: Boolean,
      value: Object
    },
    data () {
      return {
        showModalFunctionInit: false,
        bean: {},
        initBean: {type: 1, isDefault: 1},
        flag: '',
        saveLoading: false,
        modalTitle: '',
        disabled: false,
        showSaveBtn: true,
        rules: {
          code: [
            { required: true, message: '功能编码不能为空!', trigger: 'blur' },
          ],
          type: [
            { type: 'number', required: true, message: '类型不能为空!', trigger: 'blur' },
          ],
          name: [
            { required: true, message: '功能名称不能为空!', trigger: 'blur' },
          ],
          isDefault: [
            { type: 'number', required: true, message: '是否默认授权不能为空!', trigger: 'blur' },
          ],
        },
        options: {
          trigger: '.ivu-modal-header',
          body: '.ivu-modal',
          recover: true
        }
      }
    }, methods: {
      ok (name) {
        this.$refs[name].validate((valid) => {
          if (!valid) {
            return
          }//表单校验失败则返回
          this.saveLoading = true
          //this.showModalFunctionInit = false;
          if (this.flag == 'edit') {
            let params = this.bean
            delete params['createTime']
            delete params['modifyTime']
            //执行修改操作
            editFunctionInit(params).then(data => {
              if (!data.status) {
                this.$Message.error(data.error.message)
                this.saveLoading = false
                console.log(data)
                return false
              }
              this.$Message.success('操作成功！')
              this.closeAndRefresh()
            }).catch(err => {
              this.$Message.error('操作失败！')
              this.saveLoading = false
              console.log(err)
            })
          } else if (this.flag == 'add') {
            delete this.bean['createTime']
            delete this.bean['modifyTime']
            //执行添加操作
            addFunctionInit(this.bean).then(data => {
              if (!data.status) {
                this.$Message.error(data.error.message)
                this.saveLoading = false
                console.log(data)
                return false
              }
              this.$Message.success('操作成功！')
              this.closeAndRefresh()
            }).catch(err => {
              this.$Message.error('操作失败！')
              this.saveLoading = false
              console.log(err)
            })
          }
        })

      },
      cancel () {
        this.showModalFunctionInit = false
        this.$emit('update:show', false)
        //重置校验结果
        this.$refs['functionInitForm'].resetFields()
      },
      closeAndRefresh () {
        this.saveLoading = false
        this.cancel()
        this.$emit('reload-data')
      },
    },
    mounted () {
      $this = this
      this.bean = this.initBean
    },
    watch: {
      show: {
        immediate: true,
        handler: function () {
          this.showModalFunctionInit = this.show
        }
      },
      value: {
        immediate: true,
        handler: function () {
          //赋值
          this.bean = this.value.bean == null ? Object.assign({}, this.initBean) : JSON.parse(JSON.stringify(this.value.bean))
          this.flag = this.value.flag
          this.modalTitle = this.value.title
          //如果时查看的功能，要将所有input框只读，并且去掉保存按钮
          if (this.flag == 'view') {
            this.disabled = true
            this.showSaveBtn = false
          } else {
            this.disabled = false
            this.showSaveBtn = true
          }
        }
      }
    }

  }
</script>

<style scoped>
  .ivu-form-item-search {
    margin-bottom: 21px;
  }
</style>
